package repository

import (
	"fmt"
	"strings"

	"be.ems/src/framework/datasource"
	"be.ems/src/framework/logger"
	"be.ems/src/framework/utils/parse"
	"be.ems/src/framework/utils/repo"
	"be.ems/src/modules/network_data/model"
)

// 实例化数据层 UDMAuthUser 结构体
var NewUDMAuthUser = &UDMAuthUser{
	selectSql: `select id, imsi, ne_id, amf, status, ki, algo_index, opc from u_auth_user`,

	resultMap: map[string]string{
		"id":         "ID",
		"imsi":       "IMSI",
		"ne_id":      "NeId",
		"amf":        "Amf",
		"status":     "Status",
		"ki":         "Ki",
		"algo_index": "AlgoIndex",
		"opc":        "Opc",
	},
}

// UDMAuthUser UDM鉴权信息表 数据层处理
type UDMAuthUser struct {
	// 查询视图对象SQL
	selectSql string
	// 结果字段与实体映射
	resultMap map[string]string
}

// convertResultRows 将结果记录转实体结果组
func (r *UDMAuthUser) convertResultRows(rows []map[string]any) []model.UDMAuthUser {
	arr := make([]model.UDMAuthUser, 0)
	for _, row := range rows {
		item := model.UDMAuthUser{}
		for key, value := range row {
			if keyMapper, ok := r.resultMap[key]; ok {
				repo.SetFieldValue(&item, keyMapper, value)
			}
		}
		arr = append(arr, item)
	}
	return arr
}

// ClearAndInsert 清空ne_id后新增实体
func (r *UDMAuthUser) ClearAndInsert(neId string, uArr []model.UDMAuthUser) int64 {
	// 不指定neID时，用 TRUNCATE 清空表快
	// _, err := datasource.ExecDB("", "TRUNCATE TABLE u_auth_user", nil)
	_, err := datasource.ExecDB("", "DELETE FROM u_auth_user WHERE ne_id = ?", []any{neId})
	if err != nil {
		logger.Errorf("TRUNCATE err => %v", err)
	}
	return r.Inserts(uArr)
}

// SelectPage 根据条件分页查询
func (r *UDMAuthUser) SelectPage(query map[string]any) map[string]any {
	// 查询条件拼接
	var conditions []string
	var params []any
	if v, ok := query["imsi"]; ok && v != "" {
		conditions = append(conditions, "imsi like concat(concat('%', ?), '%')")
		params = append(params, strings.Trim(v.(string), " "))
	}
	if v, ok := query["neId"]; ok && v != "" {
		conditions = append(conditions, "ne_id = ?")
		params = append(params, v)
	}
	if v, ok := query["imsis"]; ok && v != "" {
		placeholder := repo.KeyPlaceholderByQuery(len(v.([]any)))
		conditions = append(conditions, fmt.Sprintf("imsi in (%s)", placeholder))
		for _, v := range v.([]any) {
			params = append(params, v.(string))
		}
	}

	// 构建查询条件语句
	whereSql := ""
	if len(conditions) > 0 {
		whereSql += " where " + strings.Join(conditions, " and ")
	}

	result := map[string]any{
		"total": 0,
		"rows":  []model.UDMAuthUser{},
	}

	// 查询数量 长度为0直接返回
	totalSql := "select count(1) as 'total' from u_auth_user"
	totalRows, err := datasource.RawDB("", totalSql+whereSql, params)
	if err != nil {
		logger.Errorf("total err => %v", err)
		return result
	}
	total := parse.Number(totalRows[0]["total"])
	if total == 0 {
		return result
	} else {
		result["total"] = total
	}

	// 分页
	pageNum, pageSize := repo.PageNumSize(query["pageNum"], query["pageSize"])
	pageSql := " limit ?,? "
	params = append(params, pageNum*pageSize)
	params = append(params, pageSize)

	// 排序
	orderSql := ""
	if v, ok := query["sortField"]; ok && v != "" {
		sortSql := v.(string)
		if o, ok := query["sortOrder"]; ok && o != nil && v != "" {
			if o == "desc" {
				sortSql += " desc "
			} else {
				sortSql += " asc "
			}
		}
		orderSql = fmt.Sprintf(" order by %s ", sortSql)
	}

	// 查询数据
	querySql := r.selectSql + whereSql + orderSql + pageSql
	results, err := datasource.RawDB("", querySql, params)
	if err != nil {
		logger.Errorf("query err => %v", err)
	}

	// 转换实体
	result["rows"] = r.convertResultRows(results)
	return result
}

// SelectList 根据实体查询
func (r *UDMAuthUser) SelectList(u model.UDMAuthUser) []model.UDMAuthUser {
	// 查询条件拼接
	var conditions []string
	var params []any
	if u.IMSI != "" {
		conditions = append(conditions, "imsi = ?")
		params = append(params, u.IMSI)
	}
	if u.NeId != "" {
		conditions = append(conditions, "ne_id = ?")
		params = append(params, u.NeId)
	}

	// 构建查询条件语句
	whereSql := ""
	if len(conditions) > 0 {
		whereSql += " where " + strings.Join(conditions, " and ")
	}

	// 查询数据
	querySql := r.selectSql + whereSql + " order by imsi asc "
	results, err := datasource.RawDB("", querySql, params)
	if err != nil {
		logger.Errorf("query err => %v", err)
	}

	// 转换实体
	return r.convertResultRows(results)
}

// SelectByIMSIAndNeID 通过imsi和ne_id查询
func (r *UDMAuthUser) SelectByIMSIAndNeID(imsi, neId string) model.UDMAuthUser {
	querySql := r.selectSql + " where imsi = ? and ne_id = ?"
	results, err := datasource.RawDB("", querySql, []any{imsi, neId})
	if err != nil {
		logger.Errorf("query err => %v", err)
		return model.UDMAuthUser{}
	}
	// 转换实体
	rows := r.convertResultRows(results)
	if len(rows) > 0 {
		return rows[0]
	}
	return model.UDMAuthUser{}
}

// Insert 批量添加
func (r *UDMAuthUser) Inserts(uArr []model.UDMAuthUser) int64 {
	tx := datasource.DefaultDB().CreateInBatches(uArr, 3000)
	if err := tx.Error; err != nil {
		logger.Errorf("CreateInBatches err => %v", err)
	}
	return tx.RowsAffected
}

// Delete 删除实体
func (r *UDMAuthUser) Delete(imsi, neId string) int64 {
	tx := datasource.DefaultDB().Where("imsi = ? and ne_id = ?", imsi, neId).Delete(&model.UDMAuthUser{})
	if err := tx.Error; err != nil {
		logger.Errorf("Delete err => %v", err)
	}
	return tx.RowsAffected
}

// DeletePrefixByIMSI 删除前缀匹配的实体
func (r *UDMAuthUser) DeletePrefixByIMSI(neId, imsi string) int64 {
	tx := datasource.DefaultDB().Where("imsi like concat(?, '%') and ne_id = ?", imsi, neId).Delete(&model.UDMAuthUser{})
	if err := tx.Error; err != nil {
		logger.Errorf("DeletePrefixByIMSI err => %v", err)
	}
	return tx.RowsAffected
}
